diff -rup nginx-0.7.61/src/http/modules/ngx_http_log_module.c ./src/http/modules/ngx_http_log_module.c
--- nginx-0.7.61/src/http/modules/ngx_http_log_module.c	2009-08-24 23:24:58.000000000 +0000
+++ ./src/http/modules/ngx_http_log_module.c	2009-08-24 23:25:18.000000000 +0000
@@ -74,6 +74,7 @@ typedef struct {
     ngx_str_t                   name;
     size_t                      len;
     ngx_http_log_op_run_pt      run;
+    ngx_http_log_op_getlen_pt   getlen;
 } ngx_http_log_var_t;
 
 
@@ -205,23 +206,25 @@ static ngx_str_t  ngx_http_combined_fmt 
 
 
 static ngx_http_log_var_t  ngx_http_log_vars[] = {
-    { ngx_string("connection"), NGX_ATOMIC_T_LEN, ngx_http_log_connection },
-    { ngx_string("pipe"), 1, ngx_http_log_pipe },
+    { ngx_string("connection"), NGX_ATOMIC_T_LEN, ngx_http_log_connection, NULL },
+    { ngx_string("pipe"), 1, ngx_http_log_pipe, NULL },
     { ngx_string("time_local"), sizeof("28/Sep/1970:12:00:00 +0600") - 1,
-                          ngx_http_log_time },
-    { ngx_string("msec"), NGX_TIME_T_LEN + 4, ngx_http_log_msec },
+                          ngx_http_log_time, NULL },
+    { ngx_string("time_custom"), 0,
+                          ngx_http_log_time_custom, ngx_http_log_time_custom_getlen },
+    { ngx_string("msec"), NGX_TIME_T_LEN + 4, ngx_http_log_msec, NULL },
     { ngx_string("request_time"), NGX_TIME_T_LEN + 4,
-                          ngx_http_log_request_time },
-    { ngx_string("status"), 3, ngx_http_log_status },
-    { ngx_string("bytes_sent"), NGX_OFF_T_LEN, ngx_http_log_bytes_sent },
+                          ngx_http_log_request_time, NULL },
+    { ngx_string("status"), 3, ngx_http_log_status, NULL },
+    { ngx_string("bytes_sent"), NGX_OFF_T_LEN, ngx_http_log_bytes_sent, NULL },
     { ngx_string("body_bytes_sent"), NGX_OFF_T_LEN,
-                          ngx_http_log_body_bytes_sent },
+                          ngx_http_log_body_bytes_sent, NULL },
     { ngx_string("apache_bytes_sent"), NGX_OFF_T_LEN,
-                          ngx_http_log_body_bytes_sent },
+                          ngx_http_log_body_bytes_sent, NULL },
     { ngx_string("request_length"), NGX_SIZE_T_LEN,
-                          ngx_http_log_request_length },
+                          ngx_http_log_request_length, NULL },
 
-    { ngx_null_string, 0, NULL }
+    { ngx_null_string, 0, NULL, NULL }
 };
 
 
@@ -1262,24 +1265,14 @@ ngx_http_log_compile_format(ngx_conf_t *
                         && ngx_strncmp(v->name.data, var.data, var.len) == 0)
                     {
                         op->len = v->len;
-                        op->getlen = NULL;
+                        op->getlen = v->getlen;
                         op->run = v->run;
-                        op->data = 0;
+                        op->data = v->getlen ? (uintptr_t) fmt : 0;
 
                         goto found;
                     }
                 }
 
-                if (var.len == sizeof "time_custom" - 1
-                 && ngx_strncmp(var.data, "time_custom", var.len) == 0) {
-                    op->len = 0;
-                    op->getlen = ngx_http_log_time_custom_getlen;
-                    op->run = ngx_http_log_time_custom;
-                    op->data = (uintptr_t) fmt;
-
-                    goto found;
-                }
-
                 if (ngx_http_log_variable_compile(cf, op, &var) != NGX_OK) {
                     return NGX_CONF_ERROR;
                 }
